(** The type of binary operators. *)
type bop = 
  | Add
  | Mul
  | Sub
  | Div

  | Leq
  | Geq
  | Lt
  | Gt

(** The type of the abstract syntax tree (AST). *)
type expr =
  | Var of string
  | Int of int
  | Bool of bool  
  | Binop of bop * expr * expr
  | Let of string * expr * expr
  | If of expr * expr * expr
  | Func of string * expr
  | Call of expr * expr
