(** The type of binary operators. *)
type bop = 
  | Add
  | Mul
  | Sub
  | Div

  | Leq
  | Geq
  | Lt
  | Gt

type typ =
  | IntType
  | BoolType
  | FuncType of typ * typ

(** The type of the abstract syntax tree (AST). *)
type expr =
  | Var of string
  | Int of int
  | Bool of bool  
  | Binop of bop * expr * expr
  | Let of string * typ * expr * expr
  | If of expr * expr * expr
  | Func of string * typ * expr
  | Call of expr * expr


type environment = (string * typ) list
